package cz.vutbr.fit.gja.androiddrive;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.GoogleApiClient.ConnectionCallbacks;
import com.google.android.gms.common.api.GoogleApiClient.OnConnectionFailedListener;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.drive.Drive;
import com.google.android.gms.drive.DriveApi.DriveContentsResult;
import com.google.android.gms.drive.DriveApi.DriveIdResult;
import com.google.android.gms.drive.DriveApi.MetadataBufferResult;
import com.google.android.gms.drive.DriveFile;
import com.google.android.gms.drive.DriveFolder;
import com.google.android.gms.drive.DriveFolder.DriveFileResult;
import com.google.android.gms.drive.DriveFolder.DriveFolderResult;
import com.google.android.gms.drive.DriveId;
import com.google.android.gms.drive.DriveResource.MetadataResult;
import com.google.android.gms.drive.MetadataChangeSet;
import com.google.android.gms.drive.query.Filters;
import com.google.android.gms.drive.query.Query;
import com.google.android.gms.drive.query.SearchableField;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.googleapis.extensions.android.gms.auth.GoogleAccountCredential;
import com.google.api.client.http.FileContent;
import com.google.api.client.http.GenericUrl;
import com.google.api.client.http.HttpResponse;
import com.google.api.client.json.gson.GsonFactory;
import com.google.api.services.drive.Drive.Builder;
import com.google.api.services.drive.DriveScopes;
import com.google.api.services.drive.model.File;
import com.google.api.services.drive.model.ParentReference;

//import android.support.v7.app.ActionBarActivity;
import android.app.Activity;
import android.content.Intent;
import android.content.IntentSender;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity implements ConnectionCallbacks,OnConnectionFailedListener{
  
  public static final int RESOLVE_CONNECTION_REQUEST_CODE = 1;
  public static final int REQUEST_CODE_CREATOR = 2;
  public static final int COMPLETE_AUTHORIZATION_REQUEST_CODE = 3;
  GoogleApiClient mGoogleApiClient;
  com.google.api.services.drive.Drive drive;
  //com.google.android.gms.drive.Drive drive; 
  private DriveId mFolderDriveId;
  
    private class BackgroundTask extends
      AsyncTask<Settings, Void, String> {
      
      Settings settings;
  
    @Override
    protected void onPostExecute(String result) {
      TextView resultView = (TextView) findViewById(R.id.result);
      //String opType=settings.getOpType();
      resultView.setText(settings.getOpType()+" "+result);
    }
  
    @Override
    protected String doInBackground(Settings... arg) {
      settings=arg[0];
      String opType=settings.getOpType();
      if (opType.equals("Upload"))
        return uploadFile(settings);
      else
        return download(settings);
        

    }
  }
    
    
    private class Settings implements Serializable{
    /**
     * 
     */
    private static final long serialVersionUID = 6483579793931205045L;
    private String opType;
    private String id;
    private String description="example";
    private String mimeType="image/png";
    private String filename="image.png";
    private String title="image";
    private String path;
    
    public Settings(String opType,String id){
      this.opType=opType;
      this.id=id;
    }

    public String getOpType() {
      return opType;
    }

    public void setOpType(String opType) {
      this.opType = opType;
    }

    public String getId() {
      return id;
    }

    public void setId(String id) {
      this.id = id;
    }

    public String getDescription() {
      return description;
    }

    public void setDescription(String description) {
      this.description = description;
    }

    public String getMimeType() {
      return mimeType;
    }

    public void setMimeType(String mimeType) {
      this.mimeType = mimeType;
    }

    public String getFilename() {
      return filename;
    }

    public void setFilename(String filename) {
      this.filename = filename;
    }

    public String getTitle() {
      return title;
    }

    public void setTitle(String title) {
      this.title = title;
    }

    public String getPath() {
      return path;
    }

    public void setPath(String path) {
      this.path = path;
    }
    }
    
    private String uploadFile(Settings settings) {
      // File's metadata.
      File body = new File();
      body.setTitle(settings.getTitle());
      body.setDescription(settings.getDescription());
      body.setMimeType(settings.getMimeType());
      body.setParents(Arrays.asList(new ParentReference().setId(settings.getId())));
      // File's content.
      java.io.File fileContent = new java.io.File("/storage/sdcard/Download/in.png");
      FileContent mediaContent = new FileContent(settings.getMimeType(), fileContent);
      try {
        drive.files().insert(body, mediaContent).execute();
        return "Success";
      } catch (IOException e) {
        System.out.println("An error occured: " + e);
        return "Failure";
      }
    }
    
    private String download(Settings settings){
      
    try {
      InputStream stream=null;
      File file=drive.files().get(settings.getId()).execute();
        if (file.getDownloadUrl() != null && file.getDownloadUrl().length() > 0) {
            try {
              HttpResponse resp =
                drive.getRequestFactory().buildGetRequest(new GenericUrl(file.getDownloadUrl()))
                .execute();
                stream=resp.getContent();
            } catch (IOException e) {
              e.printStackTrace();
              return "Failure";
            }
        } else {
          // The file doesn't have any content stored on Drive.
          return "Failure";
        }
        java.io.File jFile = new java.io.File("/storage/sdcard/Download/myfile");
        FileOutputStream fileStream = new FileOutputStream(jFile);
        byte buffer[] = new byte[1024];
        int length;
        while ((length=stream.read(buffer))>0) {
          fileStream.write(buffer, 0, length);
        }
        fileStream.close();
        stream.close();
        return "Success";
    } catch (IOException e) {        
      // Handle IOExceptions here...
      return "Failure";
    }
  }
    
  ResultCallback<MetadataResult> createdCallback=new ResultCallback<MetadataResult>(){

    @Override
    public void onResult(MetadataResult result) {

      Button upload=(Button) findViewById(R.id.upload);
      upload.setEnabled(true);
      Button insertfile=(Button) findViewById(R.id.insertfile);
      insertfile.setEnabled(true);
      TextView resultView = (TextView) findViewById(R.id.result);
      resultView.setText("Folder created: "+result.getMetadata().getTitle());
    }
      
  };
    
  ResultCallback<DriveFolderResult> folderCreatedCallback = new
    ResultCallback<DriveFolderResult>() {
      @Override
      public void onResult(DriveFolderResult result) {
        if (!result.getStatus().isSuccess()) {
          Toast.makeText(MainActivity.this, "Error while trying to create the folder",Toast.LENGTH_LONG).show();
          return;
        }
        Toast.makeText(MainActivity.this, "Created a folder: " + result.getDriveFolder().getDriveId(),Toast.LENGTH_LONG).show();
        result.getDriveFolder().getMetadata(mGoogleApiClient).setResultCallback(createdCallback);
      }
    };
    
  ResultCallback<MetadataBufferResult> uploadCallback = new 
    ResultCallback<MetadataBufferResult>(){
      @Override
      public void onResult(MetadataBufferResult result) {
        Settings s=new Settings("Upload",result.getMetadataBuffer().get(0).getDriveId().getResourceId());
        (new BackgroundTask()).execute(s);
        result.getMetadataBuffer().release();
      }
    };
    
  ResultCallback<MetadataBufferResult> downloadCallback = new 
    ResultCallback<MetadataBufferResult>(){
      @Override
      public void onResult(MetadataBufferResult result) {
        Settings s=new Settings("Download",result.getMetadataBuffer().get(0).getDriveId().getResourceId());
        (new BackgroundTask()).execute(s);
        result.getMetadataBuffer().release();
      
      }
    };
    
  ResultCallback<MetadataBufferResult> insertFileCallback = new 
    ResultCallback<MetadataBufferResult>(){
      @Override
      public void onResult(MetadataBufferResult result) {
        Drive.DriveApi.fetchDriveId(mGoogleApiClient, result.getMetadataBuffer().get(0).getDriveId().getResourceId()).setResultCallback(idCallback);
        result.getMetadataBuffer().release();
      }
    };
    
  final private ResultCallback<DriveIdResult> idCallback = new 
    ResultCallback<DriveIdResult>() {
      @Override
      public void onResult(DriveIdResult result) {
        if (!result.getStatus().isSuccess()) {
          Toast.makeText(MainActivity.this,"Cannot find DriveId. Are you authorized to view this file?",Toast.LENGTH_LONG).show();;
          return;
        }
        mFolderDriveId = result.getDriveId();
        Drive.DriveApi.newDriveContents(mGoogleApiClient).setResultCallback(contentsResult);

        Button download=(Button) findViewById(R.id.download);
        download.setEnabled(true);

      }
    };
    
  final private ResultCallback<DriveContentsResult> contentsResult = new
    ResultCallback<DriveContentsResult>() {
      @Override
      public void onResult(DriveContentsResult result) {
        if (!result.getStatus().isSuccess()) {
          Toast.makeText(MainActivity.this,"Error while trying to create new file contents",Toast.LENGTH_LONG).show();
          return;
        }
        DriveFolder folder = mFolderDriveId.asDriveFolder();
        MetadataChangeSet changeSet = new MetadataChangeSet.Builder()
          .setTitle("myfile")
          .setMimeType("text/plain")
          .setStarred(true).build();
        folder.createFile(mGoogleApiClient, changeSet, result.getDriveContents())
          .setResultCallback(fileCallback);
      }
    };
  
  final private ResultCallback<DriveFileResult> fileCallback = new
    ResultCallback<DriveFileResult>() {
      @Override
      public void onResult(DriveFileResult result) {
        if (!result.getStatus().isSuccess()) {
          Toast.makeText(MainActivity.this,"Error while trying to create the file",Toast.LENGTH_LONG).show();
          return;
        }
        TextView resultView=(TextView) findViewById(R.id.result);
        resultView.setText("Created a file: " + result.getDriveFile().getDriveId());
        Button editFile=(Button) findViewById(R.id.editfile);
        editFile.setEnabled(true);
        Button viewContents=(Button) findViewById(R.id.viewfile);
        viewContents.setEnabled(true);
      }
    };
  
  private void initDrive(){
    ArrayList<String> scopes=new ArrayList<String>();
    scopes.add(DriveScopes.DRIVE);

    GoogleAccountCredential credential = GoogleAccountCredential.usingOAuth2(MainActivity.this,scopes );
    credential.setSelectedAccountName("kourilj24@gmail.com");
    drive = new Builder(AndroidHttp.newCompatibleTransport(), new GsonFactory(), credential).setApplicationName("AndroidDrive").build();
    Button create=(Button) findViewById(R.id.create);
    create.setEnabled(true);
    Toast.makeText(this, "Drive initialized", Toast.LENGTH_SHORT).show();
  }

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    
    mGoogleApiClient = new GoogleApiClient.Builder(this)
      .addApi(Drive.API)
      .addScope(Drive.SCOPE_FILE)
      .addConnectionCallbacks(this)
      .addOnConnectionFailedListener(this)
      .build();

    Button init=(Button) findViewById(R.id.drive);
    init.setOnClickListener(new View.OnClickListener() {  
      @Override
      public void onClick(View v) {
        initDrive();
      }
    });
    init.setEnabled(false);
    
    Button create=(Button) findViewById(R.id.create);
    create.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        String folderName="Pokus";
        MetadataChangeSet changeSet = new MetadataChangeSet.Builder()
          .setTitle(folderName).build();
        Drive.DriveApi.getRootFolder(mGoogleApiClient).createFolder(
          mGoogleApiClient, changeSet).setResultCallback(folderCreatedCallback);
      }
    });
    create.setEnabled(false);
    
    Button upload=(Button) findViewById(R.id.upload);
    upload.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {/*
        Query query = new Query.Builder()
            .addFilter(Filters.eq(SearchableField.TITLE, "Pokus")).build();
        Drive.DriveApi.getRootFolder(mGoogleApiClient).queryChildren(mGoogleApiClient, query).setResultCallback(uploadCallback);
        */
        Settings s=new Settings("Upload",Drive.DriveApi.getRootFolder(mGoogleApiClient).getDriveId().getResourceId());
        (new BackgroundTask()).execute(s);
      }
    });
    upload.setEnabled(false);
    
    Button download=(Button) findViewById(R.id.download);
    download.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        Query query = new Query.Builder()
          .addFilter(Filters.eq(SearchableField.TITLE, "myfile")).build();
        Drive.DriveApi.query(mGoogleApiClient, query).setResultCallback(downloadCallback);
        
      }
    });
    download.setEnabled(false);
    
    Button insertfile=(Button) findViewById(R.id.insertfile);
    insertfile.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        Query query = new Query.Builder()
          .addFilter(Filters.eq(SearchableField.TITLE, "Pokus")).build();
        Drive.DriveApi.getRootFolder(mGoogleApiClient).queryChildren(mGoogleApiClient, query).setResultCallback(insertFileCallback);
        
      }
    });
    insertfile.setEnabled(false);
    
    Button editFile=(Button) findViewById(R.id.editfile);
    editFile.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        Query query = new Query.Builder()
          .addFilter(Filters.eq(SearchableField.TITLE, "myfile")).build();
        Drive.DriveApi.query(mGoogleApiClient, query).setResultCallback(editContentsCallback);
      }
    });
    editFile.setEnabled(false);
    
    Button viewButton=(Button) findViewById(R.id.viewfile);
    viewButton.setOnClickListener(new View.OnClickListener() {
      @Override
      public void onClick(View v) {
        Query query = new Query.Builder()
          .addFilter(Filters.eq(SearchableField.TITLE, "myfile")).build();
        Drive.DriveApi.query(mGoogleApiClient, query).setResultCallback(viewContentsCallback);
      }
    });
    viewButton.setEnabled(false);
    
  }  // onCreate()
  
  ResultCallback<MetadataBufferResult> editContentsCallback = new 
    ResultCallback<MetadataBufferResult>(){
      @Override
      public void onResult(MetadataBufferResult result) {
        Drive.DriveApi.fetchDriveId(mGoogleApiClient, result.getMetadataBuffer().get(0).getDriveId().getResourceId())
          .setResultCallback(editIdCallback);
        result.getMetadataBuffer().release();
      }
    };
    
  ResultCallback<DriveIdResult> editIdCallback = new 
    ResultCallback<DriveIdResult>() {
      @Override
      public void onResult(DriveIdResult result) {
        if (!result.getStatus().isSuccess()) {
          Toast.makeText(MainActivity.this, "Cannot find DriveId. Are you authorized to view this file?", Toast.LENGTH_SHORT).show();
          return;
        }
        DriveFile file = result.getDriveId().asDriveFile();
        new EditContents().execute(file);
      }
    };
  
  class EditContents extends AsyncTask<DriveFile, Void, Boolean> {
    @Override
    protected Boolean doInBackground(DriveFile... args) {
      DriveFile file = args[0];
      try {
        DriveContentsResult contentsResult = file
          .open(mGoogleApiClient, DriveFile.MODE_WRITE_ONLY, null).await();
        if (!contentsResult.getStatus().isSuccess()) {
          return false;
        }
        OutputStream outputStream = contentsResult.getDriveContents().getOutputStream();
        outputStream.write("Hello world".getBytes());
        //com.google.android.gms.common.api.Status status = file.commitAndCloseContents(mGoogleApiClient, contentsResult.getDriveContents()).await();
        contentsResult.getDriveContents().commit(mGoogleApiClient, null);
        com.google.android.gms.common.api.Status status=contentsResult.getStatus();
        return status.getStatus().isSuccess();
      } catch (IOException e) {
        Log.e("MainActivity", "IOException while appending to the output stream", e);
      }
      return false;
    }

    @Override
    protected void onPostExecute(Boolean result) {
      if (!result) {
        Toast.makeText(MainActivity.this, "Error while editing contents", Toast.LENGTH_LONG).show();
        return;
      }
      Toast.makeText(MainActivity.this, "Successfully edited contents", Toast.LENGTH_LONG).show();
    }
  }
  
  ResultCallback<MetadataBufferResult> viewContentsCallback=new ResultCallback<MetadataBufferResult>(){
    @Override
    public void onResult(MetadataBufferResult result) {
      Drive.DriveApi.fetchDriveId(mGoogleApiClient, result.getMetadataBuffer().get(0).getDriveId().getResourceId())
        .setResultCallback(viewIdCallback);
      result.getMetadataBuffer().release();
    }
  };

  ResultCallback<DriveIdResult> viewIdCallback = new ResultCallback<DriveIdResult>() {
    @Override
    public void onResult(DriveIdResult result) {
      new RetrieveDriveFileContents().execute(result.getDriveId());
    }
  };

  final private class RetrieveDriveFileContents extends AsyncTask<DriveId, Boolean, String> {
    @Override
    protected String doInBackground(DriveId... params) {
      String contents = null;
      DriveFile file = params[0].asDriveFile();
      DriveContentsResult contentsResult =
        file.open(mGoogleApiClient, DriveFile.MODE_READ_ONLY, null).await();
      if (!contentsResult.getStatus().isSuccess()) {
        return null;
      }
      BufferedReader reader = new BufferedReader(
        new InputStreamReader(contentsResult.getDriveContents().getInputStream()));
      StringBuilder builder = new StringBuilder();
      String line;
      try {
        while ((line = reader.readLine()) != null) {
          builder.append(line);
        }
        contents = builder.toString();
      } catch (IOException e) {
        Log.e("MainActivity", "IOException while reading from the stream", e);
      }
            
      //file.discardContents(mGoogleApiClient, contentsResult.getDriveContents()).await();
      return contents;
    }

    @Override
    protected void onPostExecute(String result) {
      super.onPostExecute(result);
      if (result == null) {
        Toast.makeText(MainActivity.this, "Error while reading from the file",Toast.LENGTH_LONG).show();
        return;
      }
      TextView res=(TextView) findViewById(R.id.result);
      res.setText(result);
    }
  }
  
  @Override
  protected void onStart() {
    super.onStart();
    mGoogleApiClient.connect();
  }
  
  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    // Inflate the menu; this adds items to the action bar if it is present.
    getMenuInflater().inflate(R.menu.main, menu);
    return true;
  }

  @Override
  public boolean onOptionsItemSelected(MenuItem item) {
    // Handle action bar item clicks here. The action bar will
    // automatically handle clicks on the Home/Up button, so long
    // as you specify a parent activity in AndroidManifest.xml.
    int id = item.getItemId();
    if (id == R.id.action_settings) {
      return true;
    }
    return super.onOptionsItemSelected(item);
  }

  @Override
  public void onConnectionFailed(ConnectionResult result) {
    if (result.hasResolution()) {
      try {
        result.startResolutionForResult(this, RESOLVE_CONNECTION_REQUEST_CODE);
      } catch (IntentSender.SendIntentException e) {
        // Unable to resolve, message user appropriately
      }
    } else {
      //GooglePlayServicesUtil.getErrorDialog(result.getErrorCode(), this, 0).show();
      Toast.makeText(this, String.valueOf(result.getErrorCode()), Toast.LENGTH_LONG).show();
    }
  }

  @Override
  public void onConnected(Bundle connectionHint) {
    Toast.makeText(this, "Connected", Toast.LENGTH_SHORT).show();
    Button init=(Button) findViewById(R.id.drive);
    init.setEnabled(true);
  }

  @Override
  public void onConnectionSuspended(int cause) {
  }
  
  @Override
  protected void onActivityResult(final int requestCode, final int resultCode, final Intent data) {
    switch (requestCode) {
      case RESOLVE_CONNECTION_REQUEST_CODE:
        if (resultCode == RESULT_OK) {
          mGoogleApiClient.connect();
        }
        break;
    }
  }
}
