package cz.vutbr.fit.gja.androidspring;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class GoogleSearchResultListAdapter extends BaseAdapter {

  private List<GoogleSearchResult> results;
  private final LayoutInflater layoutInflater;

  public GoogleSearchResultListAdapter(Context context, List<GoogleSearchResult> results) {
    this.results = results;
    this.layoutInflater = LayoutInflater.from(context);
  }

  public int getCount() {
    return this.results != null ? this.results.size() : 0;
  }

  public GoogleSearchResult getItem(int position) {
    return this.results.get(position);
  }

  public long getItemId(int position) {
    return position;
  }

  public View getView(int position, View convertView, ViewGroup parent) {
    if (convertView == null) {
      convertView = this.layoutInflater.inflate(R.layout.google_search_results_list_item, parent, false);
    }

    GoogleSearchResult result = getItem(position);
    if (result != null) {
      TextView t = (TextView) convertView.findViewById(R.id.title);
      t.setText(removeMarkup(result.getTitle()));

      t = (TextView) convertView.findViewById(R.id.content);
      t.setText(removeMarkup(result.getContent()));
    }

    return convertView;
  }

  private String removeMarkup(String s) {
    return s.replace("<b>", "").replace("</b>", "");
  }

}
