package cz.vutbr.fit.gja.androidspring;

import java.util.List;


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class StatesListAdapter extends BaseAdapter {

  private List<State> states;
  private final LayoutInflater layoutInflater;

  public StatesListAdapter(Context context, List<State> states) {
    this.states = states;
    this.layoutInflater = LayoutInflater.from(context);
  }

  public int getCount() {
    return this.states != null ? states.size() : 0;
  }

  public State getItem(int position) {
    return this.states.get(position);
  }

  public long getItemId(int position) {
    return position;
  }

  public View getView(int position, View convertView, ViewGroup parent) {
    if (convertView == null) {
      convertView = this.layoutInflater.inflate(R.layout.states_list_item, parent, false);
    }

    State state = getItem(position);
    if (state != null) {
      TextView t = (TextView) convertView.findViewById(R.id.state_name);
      t.setText(state.getFormattedName());
    }

    return convertView;
  }

}
