package cz.vutbr.fit.gja;

import java.io.IOException;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

@Controller
public class FileUploadController {

  /**
   * Simply selects the view to render by returning its name.
   * 
   * @return REturns ID of view
   */
  @RequestMapping(value = "fileupload", method = RequestMethod.GET)
  public String fileUpload() {
    return "fileupload";
  }

  /**
   * Accepts a POST request with multipart/form-data content
   *
   * @param file the binary file
   * @return response message indicating success or failure
   */
  @RequestMapping(value = "postformdata", method = RequestMethod.POST, 
                  headers = "Content-Type=multipart/form-data")
  public @ResponseBody
  String handleFormUpload(@RequestParam("file") MultipartFile file) {

    if (!file.isEmpty()) {
      byte[] bytes = null;
      try {
        bytes = file.getBytes();
      } catch (IOException e) {

      }
      return "file upload received!  Size:[" + bytes.length + "]";
    } else {
      return "file upload failed!";
    }
  }

}
